Imports System.Security.Cryptography.Xml
Imports System.Xml

Public Class ExtendedSignedXml
    Inherits SignedXml
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal document As XmlDocument)
        MyBase.New(document)
    End Sub

    Public Sub New(ByVal elem As XmlElement)
        MyBase.New(elem)
    End Sub

    Public Overrides Function GetIdElement(ByVal document As XmlDocument, ByVal idValue As String) As XmlElement
        If document Is Nothing Then
            Throw New ArgumentException("idValue", "No pot ser nul")
        End If

        If document Is Nothing Then
            Return Nothing
        End If

        Dim nsManager As New XmlNamespaceManager(document.NameTable)
        nsManager.AddNamespace("u", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd")
        
        Dim xmlIdNodes As XmlNodeList

        xmlIdNodes = document.SelectNodes(String.Format("//*[@u:Id='{0}']", idValue), nsManager)

        If xmlIdNodes.Count > 1 Then
            Throw New InvalidOperationException("Id no nico: u:Id")
        ElseIf xmlIdNodes.Count = 1 Then
            Return xmlIdNodes(0)
        End If

        Return MyBase.GetIdElement(document, idValue)
    End Function
End Class