﻿Imports System.Xml
Imports System.Security.Cryptography.X509Certificates
Imports System.Net
Imports System.IO
Imports System.Security.Cryptography
Imports System.Security.Cryptography.Xml
Imports System.Text
Imports System.Net.Security

Public Class proxyClientWS

    Public Sub New(ByVal pathCert As String, ByVal passCert As String, ByVal entorn As String, ByVal cluster As String, ByVal servei As String)
        Me.pathCert = pathCert
        Me.passCert = passCert
        Me.url = entorn + cluster + servei
    End Sub

    Public Function procesa(ByVal peticio As String) As String
        Dim soap As XmlSoap = New XmlSoap(pathCert, passCert)
        Dim xml As String = soap.GetSignedXml(peticio)

        'Obtenim la resposta
        Dim response As String = GetResponse(xml)

        Return response
    End Function

    Private pathCert As String
    Private passCert As String
    Private url As String


    Private Function GetResponseContent(ByVal webresp As HttpWebResponse) As String

        If webresp Is Nothing Then
            Return String.Empty
        End If

        'Obtenemos stream de respuesta
        Dim stm As Stream = webresp.GetResponseStream
        Dim r As StreamReader = New StreamReader(stm)
        Dim response As String = r.ReadToEnd
        r.Close()
        Return response
    End Function

    Private Function GetResponse(ByVal sendContent As String) As String

        If sendContent Is Nothing Then
            Return String.Empty
        End If

        Dim webresp As WebResponse = Nothing
        Dim webreq As HttpWebRequest = Nothing

        'URL per consumir el serveis
        webreq = CType(WebRequest.Create(url), HttpWebRequest)
        'text/xml utf-8 POST'
        webreq.ContentType = "text/xml;charset=""utf-8"""
        webreq.Accept = "text/xml"
        webreq.Method = "POST"
        'Acció
        webreq.Headers.Add("SOAPAction", "procesa")
        'TimeOut
        webreq.Timeout = 30 * 1000

        'Evitamos el problema de confianza del certificado de servidor
        ServicePointManager.ServerCertificateValidationCallback = New RemoteCertificateValidationCallback(AddressOf ValidateCertificate)

        ' Escribimos datos post (xml soap)
        Dim aBytes() As Byte = Encoding.UTF8.GetBytes(sendContent)
        Dim stm As Stream = webreq.GetRequestStream
        stm.Write(aBytes, 0, aBytes.Length)
        stm.Close()

        ' Llamada al webservice
        Dim response As String
        Try
            webresp = webreq.GetResponse
            response = GetResponseContent(webresp)
        Catch wex As WebException
            response = GetResponseContent(wex.Response)
        End Try
        Return response

    End Function

    Private Function ValidateCertificate(ByVal sender As Object, ByVal certificate As X509Certificate, ByVal chain As X509Chain, ByVal sslPolicyErrors As SslPolicyErrors) As Boolean
        'Return True to force the certificate to be accepted.
        Return True
    End Function


    Private Class XmlSoap

        Private _storePath As String = Nothing
        Private _storePass As String = Nothing

        Public Sub New(ByVal storePath As String, ByVal storePass As String)
            Me._storePath = storePath
            Me._storePass = storePass
        End Sub

        Public Function GetSignedXml(ByVal peticio As String)
            Dim xmlSoap As String = String.Empty
            Dim BodyId As String = "Body-" + Guid.NewGuid().ToString()
            Dim binarySecurityTokenId As String = "CertId-" + Guid.NewGuid().ToString()
            Dim timeStampId As String = "TimeStamp-" + Guid.NewGuid().ToString()
            Dim x509 As X509Functions = New X509Functions
            Dim SecurityTokenReference As New XmlDocument()
            Dim signature As String = String.Empty

            Dim doc As New XmlDocument
            doc.PreserveWhitespace = True
            doc.LoadXml(peticio)
            peticio = doc.OuterXml

            SecurityTokenReference.LoadXml( _
                String.Format("<wssec:SecurityTokenReference " & _
                              "xmlns:wssec=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"">" & _
                              "<wssec:Reference URI=""#{0}"" /></wssec:SecurityTokenReference>", _
                              binarySecurityTokenId))

            xmlSoap += "<soap:Envelope xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"" " & _
                        "xmlns:u=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"">"
            xmlSoap += "<soap:Header>"
            xmlSoap += "<wssec:Security soap:mustUnderstand=""1"" " & _
                        "xmlns:wssec=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"">"

            xmlSoap += String.Format("<wssec:BinarySecurityToken " & _
                                     "ValueType=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-x509-token-profile-1.0#X509v3"" " & _
                                     "u:Id=""{0}"">", binarySecurityTokenId)
            xmlSoap += x509.GetClientCertificateBase64(Me._storePath, Me._storePass)
            xmlSoap += "</wssec:BinarySecurityToken>"
            xmlSoap += "{0}" 'Signature
            xmlSoap += String.Format("<wsu:Timestamp xmlns:wsu=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"" " & _
                                     "wsu:Id=""{0}"">", timeStampId)
            Dim timeStamp As DateTime = DateTime.UtcNow
            Console.WriteLine(timeStamp.ToString("o").Substring(0, 23) + "Z")
            xmlSoap += String.Format("<wsu:Created>{0}</wsu:Created>", timeStamp.ToString("o").Substring(0, 23) + "Z")
            xmlSoap += String.Format("<wsu:Expires>{0}</wsu:Expires>", DateAdd(DateInterval.Minute, 5, timeStamp).ToString("o").Substring(0, 23) + "Z")

            xmlSoap += "</wsu:Timestamp>"
            xmlSoap += "</wssec:Security>"
            xmlSoap += "</soap:Header>"
            xmlSoap += String.Format("<soap:Body u:Id=""{0}"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">", BodyId)
            xmlSoap += "<procesa xmlns=""http://www.openuri.org/"">" + peticio + "</procesa>"
            xmlSoap += "</soap:Body>"
            xmlSoap += "</soap:Envelope>"

            Dim uris As String() = {"#" + BodyId}
            signature = x509.CreateSignature(Me._storePath, Me._storePass, xmlSoap, uris, SecurityTokenReference.DocumentElement)
            xmlSoap = String.Format(xmlSoap, signature)

            Return xmlSoap
        End Function

    End Class

    Private Class X509Functions

        Public Function CreateSignature(ByVal storeLocation As String, _
                                        ByVal storePassword As String, _
                                        ByVal contentToSign As String, _
                                        ByVal referenceURIs As String(), _
                                        ByVal SecurityTokenReference As XmlElement) As String


            Dim xmlContentToSign As XmlDocument
            Dim cert As X509Certificate2 = GetClientCertificate(storeLocation, storePassword)
            Dim keyInfo As KeyInfo = New KeyInfo
            keyInfo.AddClause(New KeyInfoNode(SecurityTokenReference))

            Dim pvtKey As RSACryptoServiceProvider = Nothing
            If cert.HasPrivateKey Then
                pvtKey = CType(cert.PrivateKey, RSACryptoServiceProvider)
            End If

            xmlContentToSign = New XmlDocument
            xmlContentToSign.PreserveWhitespace = True
            xmlContentToSign.LoadXml(contentToSign)

            Dim signedXml As New ExtendedSignedXml(xmlContentToSign)
            signedXml.SigningKey = pvtKey

            For Each uri As String In referenceURIs
                Dim env As New XmlDsigExcC14NTransform()
                Dim reference As Reference = New Reference
                reference.Uri = uri
                reference.AddTransform(env)
                signedXml.AddReference(reference)
            Next

            signedXml.SignedInfo.CanonicalizationMethod = Xml.SignedXml.XmlDsigExcC14NTransformUrl

            signedXml.KeyInfo = keyInfo
            signedXml.ComputeSignature()
            Return signedXml.GetXml.OuterXml
        End Function

        Private Function GetClientCertificate(ByVal storeLocation As String, ByVal storePassword As String) As X509Certificate2

            Dim cert As New X509Certificate2(storeLocation, storePassword)

            If cert Is Nothing Then
                Throw New Exception(String.Format("No s'ha trobat el certificat: {0}", storeLocation))
            End If

            Return cert
        End Function

        Public Function GetClientCertificateBase64(ByVal storeLocation As String, ByVal storePassword As String) As String
            Dim cert As X509Certificate2 = GetClientCertificate(storeLocation, storePassword)
            Return Convert.ToBase64String(cert.GetRawCertData)
        End Function

    End Class

End Class